/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * This software is Copyright  2011 Yuri Gonzaga Gonalves da Costa <yuriggc at gmail>, and it is hereby released to the general public under the following terms:*
 * Redistribution and use in source and binary forms, with or without modification, are permitted.                                                                 *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
 `timescale 1 ns/ 1 ns
 
module Manager(
	PicoRst, 
	PicoClk, 
	PicoWr,
	PicoAddr,
	PicoRd,  
	PicoDataIn, 
	PicoDataOut
);
	parameter N_MODULES  = 4;
	parameter UM    = 2'd0;
	parameter DOIS  = 2'd1;
	parameter TRES  = 2'd2;
	reg[1:0] state;

	input PicoRst;
	input PicoClk;
	input PicoWr;
	input PicoRd;
	input [31:0]PicoDataIn;
	input [31:0] PicoAddr;
	output [31:0] PicoDataOut;	
	reg [31:0] PicoDataOut_r;
	reg [3:0] ACTIVES;
	
	loop L_0(
	.PicoRst(PicoRst), 
	.PicoClk(PicoClk), 
	.PicoWr(PicoWr),
	.PicoAddr(PicoAddr),
	.PicoRd(PicoRd),  
	.PicoDataIn(PicoDataIn), 
	.PicoDataOut(PicoDataOut),
	.active(ACTIVES[0])
	);
	
	loop L_1(
	.PicoRst(PicoRst), 
	.PicoClk(PicoClk), 
	.PicoWr(PicoWr),
	.PicoAddr(PicoAddr),
	.PicoRd(PicoRd),  
	.PicoDataIn(PicoDataIn), 
	.PicoDataOut(PicoDataOut),
	.active(ACTIVES[1])
	);
	
	loop L_2(
	.PicoRst(PicoRst), 
	.PicoClk(PicoClk), 
	.PicoWr(PicoWr),
	.PicoAddr(PicoAddr),
	.PicoRd(PicoRd),  
	.PicoDataIn(PicoDataIn), 
	.PicoDataOut(PicoDataOut),
	.active(ACTIVES[2])
	);
	
	loop L_3(
	.PicoRst(PicoRst), 
	.PicoClk(PicoClk), 
	.PicoWr(PicoWr),
	.PicoAddr(PicoAddr),
	.PicoRd(PicoRd),  
	.PicoDataIn(PicoDataIn), 
	.PicoDataOut(PicoDataOut),
	.active(ACTIVES[3])
	);

	always@(posedge PicoClk) begin
		if(PicoRst==1'b0)begin
			if(PicoWr)begin
				if(PicoAddr[31:24] == 8'd255)begin
					ACTIVES <= PicoAddr[7:4];
				end
			end
		end else begin
			ACTIVES <= 4'd0;
		end
	end	
endmodule

